import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)

public class Peetie extends Robot
{
    private int speed = 3;

    public void act() 
    {
        this.steuerung();
        this.checkEmmyBeruehrung();
        this.checkGeneratorBeruehrung();
    }   

    public void checkEmmyBeruehrung() {
        if(this.isTouching(Emmy.class)) {
            Emmy emmy = (Emmy)this.getOneIntersectingObject(Emmy.class);
            this.textausgeben("Hallo.");
            this.textausgeben("Ich bin Peetie.");
            this.textausgeben("Und du bist … " + emmy.name + "! - Ooooooh …");
            this.textausgeben("Deine Signalverstärkung ist " + emmy.signalverstaerkung + " … Das ist schlecht.");
            emmy.signalverstaerkung = "ultra";
            this.textausgeben("Jetzt ist deine Signalverstärkung " + emmy.signalverstaerkung + " - prima!");
            this.textausgeben("Hast du einen Secret-Code?");
            int emmysGeheimcode = emmy.secretCode;
            this.textausgeben("Hui, »protokollOmegaStarten« - was ist denn das?! Mal probieren …");
            emmy.protokollOmegaStarten(emmysGeheimcode);

            /** 
            IHR JOB:
            Setzen Sie die Klassenvariablen von Emmy auf private.
            Schreiben Sie Emmy die benötigten Zugriffsmethoden (Getter, Setter).
            Verwenden Sie diese statt des direkten Zugriffs.
             **/
        }
    }

    public void checkGeneratorBeruehrung() {
        if(this.isTouching(Powergenerator.class)) {
            Powergenerator p = (Powergenerator)this.getOneIntersectingObject(Powergenerator.class);
            this.textausgeben("Mal prüfen - Seriennummer ist " + p.seriennummer);
            this.textausgeben("Kontaktnummer zum Hersteller: " + p.telefonnummerHerstellerfirma);
            this.textausgeben("Ladezustand: " + p.ladezustandProzent);
            this.textausgeben("Aktivierungsstatus: " + p.istAktiv);
            /** 
            IHR JOB:
            Setzen Sie in Powergenerator alle Klassenvariablen auf private.
            Schreiben Sie Powergenerator die benötigten Getter und verwenden Sie sie oben.
             **/        

            this.textausgeben("Wird geladen … ");
            // Hier Ladezustand von p auf 100 setzen
            this.textausgeben("Laden erfolgreich - Neuer Ladezustand ist " + p.ladezustandProzent);

            this.textausgeben("Ändere Aktivierungsstatus: …");
            // Hier Aktivierungsstatus auf true setzen
            this.textausgeben("Neuer Aktivierungsstatus: " + p.istAktiv);
            
            this.textausgeben("Ups - Ladezustand muss um 1 erhöht werden!");
            // Hier Ladezustand um 1 erhöhen.
            this.textausgeben("Ladezustand um 1 erhöht auf " + p.ladezustandProzent);

            /** 
            IHR JOB:
            Schreiben Sie Powergenerator die benötigten Setter und verwenden Sie diese zur Änderung der Werte
             **/
        }
    }

    public void textausgeben(String pText) {
        this.getWorld().showText(pText, 640, 300);
        Greenfoot.delay(110);
    }

    public void steuerung() {
        if(Greenfoot.isKeyDown("a")) {
            this.setLocation(this.getX() - this.speed, this.getY());
        }
        if(Greenfoot.isKeyDown("d")) {
            this.setLocation(this.getX() + this.speed, this.getY());
        }
        if(Greenfoot.isKeyDown("w")) {
            this.setLocation(this.getX(), this.getY() - this.speed);
        }
        if(Greenfoot.isKeyDown("s")) {
            this.setLocation(this.getX(), this.getY() + this.speed);
        }
    }
}